RESTinio

Public Types | Private Types | List of all members
restinio::router::easy_parser_router::impl::dsl_details::special_decay< T > Struct Template Reference

A special analog of std::decay meta-function that is handles array differently. More...

`#include <easy_parser_router.hpp>`

## Public Types
using | type = typename std::conditional< std::is_array< U >::value, U, std::remove_cv_t< U > >::type

## Private Types
using | U = std::remove_reference_t< T >

## Detailed Description

template<typename T>
struct restinio::router::easy_parser_router::impl::dsl_details::special_decay< T >

A special analog of std::decay meta-function that is handles array differently.

The std::decay converts `char[]` into `char*` and that is not appropriate because `const char[]` is handled by exact_fixed_size_fragment_producer.

The special_decay keeps the type of arrays and do not handles function pointers (it's because function pointers is not used by easy-parser).

Since
  v.0.6.6

Definition at line 484 of file easy_parser_router.hpp.

## Member Typedef Documentation

## ◆ type

template<typename T >

using restinio::router::easy_parser_router::impl::dsl_details::special_decay< T >::type = typename std::conditional< std::is_array<U>::value, U, std::remove_cv_t<U> >::type

Definition at line 490 of file easy_parser_router.hpp.

## ◆ U

template<typename T >

using restinio::router::easy_parser_router::impl::dsl_details::special_decay< T >::U = std::remove_reference_t<T>
| private

Definition at line 487 of file easy_parser_router.hpp.

The documentation for this struct was generated from the following file:

- restinio/router/easy_parser_router.hpp